// 04/09/09 began from http://cr.yp.to/chacha.html

#ifndef CHA_CHA_HPP
#define CHA_CHA_HPP

#include "Platform.hpp"

namespace cipher
{
	class ChaCha
	{
		u32 state[16];

	public:
		~ChaCha();

	public:
		// 256-bit (32-byte) key
		void Key(const void *key);

		// 64-bit IV
		void Begin(const u32 iv[2]);

		// Message with any number of bytes
		void Crypt(const void *in, void *out, int bytes);
	};
}

#endif // CHA_CHA_HPP
